// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.pmfm;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Une fraction analysée est un composant du support sur lequel
 * porte l'analyse.
 * </p>
 * <p>
 * Les fractions analysées sont généralement des fractions
 * "organiques", au sens d'une classification par partie d'un même
 * organisme,
 * </p>
 * <p>
 * ex : foie, écaille, reins, dents, otolithe...
 * </p>
 * <p>
 * Elles peuvent aussi être un sous ensemble quelconque du support.
 * Par exemple, dans le cas des engins : le bras, …
 * </p>
 * <p>
 * Les fractions dites "systématiques", au sens d'une
 * classification systématique (ex : poisson : Cyprinidae /
 * Cyprinus / Cyprinus carpio...) ne sont pas considérées comme des
 * fractions au sens de l'entité, mais comme une précision apportée
 * sur l'individu. Représentées par les entités "taxon" et "groupe
 * de taxon", elles ne font pas partie de la liste des fractions
 * analysées.
 * </p>
 * <p>
 * Etant une liste de référence, une procédure stricte pour la
 * création de nouvelles fractions analysées pourra être mise en
 * place (On pourra s'inspirer des procédures utilisées dans
 * Quadrige2, qui utilisent le référentiel national du SANDRE).
 * </p>
 * <p>
 * Nombre de lignes : 10
 * </p>
 */
public abstract class Fraction
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 889767786548315432L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant unique de la fraction. Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String name;

    /**
     * <p>
     * Description courte de la fraction.
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.String description;

    /**
     * <p>
     * Description longue de la fraction.
     * </p>
     */
    public java.lang.String getDescription()
    {
        return this.description;
    }

    public void setDescription(java.lang.String description)
    {
        this.description = description;
    }

    private java.util.Date creationDate;

    /**
     * 
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.Matrix> matrixes = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.pmfm.Matrix>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.Matrix> getMatrixes()
    {
        return this.matrixes;
    }

    public void setMatrixes(java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.Matrix> matrixes)
    {
        this.matrixes = matrixes;
    }



    private fr.ifremer.adagio.core.dao.referential.Status status;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.Status getStatus()
    {
        return this.status;
    }

    public void setStatus(fr.ifremer.adagio.core.dao.referential.Status status)
    {
        this.status = status;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Fraction))
        {
            return false;
        }
        final Fraction that = (Fraction)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Fraction}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Fraction}.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Fraction newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Fraction entity = new fr.ifremer.adagio.core.dao.referential.pmfm.FractionImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Fraction}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Fraction newInstance(java.lang.String name, java.util.Date creationDate, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Fraction entity = newInstance();
            entity.setName(name);
            entity.setCreationDate(creationDate);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Fraction}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Fraction newInstance(java.lang.String name, java.lang.String description, java.util.Date creationDate, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.Matrix> matrixes, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Fraction entity = newInstance();
            entity.setName(name);
            entity.setDescription(description);
            entity.setCreationDate(creationDate);
            entity.setUpdateDate(updateDate);
            entity.setMatrixes(matrixes);
            entity.setStatus(status);
            return entity;
        }
    }
    
// Fraction.java merge-point
}